﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PripremaNoviZad
{
    public class Book : IComparable<Book>
    {
        private const char Del = '-';
        private bool vraceno;
        public string ISBN { get; set; }
        public string Naslov { get; set; }
        public string Autor { get; set; }
        public int IdPosuditelja { get; set; }

        private static bool ParseBool(string s)
        {
            if (s == "da")
            {
                return true;
            }
            else if (s == "ne")
            {
                return false;
            }

            return false;
        }
        public bool Vraceno {
            get => vraceno;
            set
            {
                if (ParseBool(value.ToString()))
                {
                    vraceno = true;
                }
                vraceno = false;
            }
        }

        public int CompareTo(Book other)
        {
            return ISBN.CompareTo(other.ISBN);
        }

        public override bool Equals(object obj)
        {
            return obj is Book book &&
                   ISBN == book.ISBN;
        }

        public string Format()
        {
            return $"{ISBN}{Del}{Naslov}{Del}{Autor}{Del}{IdPosuditelja}{Del}{Vraceno}";
        }

        public override string ToString()
        {
            return $"{ISBN}, {Naslov}, {Autor}, {IdPosuditelja}, {Vraceno}";
        }

        public static Book Parse(string s)
        {
            string[] details = s.Split(Del);
            try
            {
                return new Book
                {
                    ISBN = details[0],
                    Naslov = details[1],
                    Autor = details[2],
                    IdPosuditelja = details.Length > 3 ? int.Parse(details[3]) : 0,
                    Vraceno = details.Length > 4 ? ParseBool(details[4]) : false,
                };
            }
            catch {
                throw new Exception();
            }

        }

        public override int GetHashCode()
        {
            return 324950537 + EqualityComparer<string>.Default.GetHashCode(ISBN);
        }
    }
}
